#include "InspCls.h"

#define Inherited InspClsData

InspCls::InspCls(QWidget* parent,const char* name):Inherited( parent, name ) {

mode=mmode=nsel=0;
im1=new EMData;
im2=new EMData;
im3=new EMData;
swap=0;

//connect(brite,SIGNAL(valueChanged(int)),this,SLOT(newBC(int)));
//connect(cont,SIGNAL(valueChanged(int)),this,SLOT(newBC(int)));
connect(imgn,SIGNAL(valueChanged(int)),this,SLOT(update(int)));
connect(imgn2,SIGNAL(valueChanged(int)),this,SLOT(update(int)));
connect(gobut,SIGNAL(clicked()),this,SLOT(go()));
connect(Mode,SIGNAL(activated(int)),SLOT(newMode(int)));
connect(MMode,SIGNAL(activated(int)),SLOT(newMidMode(int)));
connect(Normsel,SIGNAL(activated(int)),SLOT(newNormsel(int)));
}


InspCls::~InspCls() {
if (im1) delete im1;
if (im2) delete im2;
if (im3) delete im3;
}

void InspCls::setFile(const char *file) {
int n;

filespec=file;
if (filespec.contains("/classes")|| strncmp(filespec,"classes",7)==0) {
	Mode->setCurrentItem(2);
	newMode(2);
}
else if (filespec.contains("/cls") || strncmp(filespec,"cls",3)==0 ) {
	Mode->setCurrentItem(1);
	newMode(1);
}
else {
	Mode->setCurrentItem(0);
	newMode(0);
}

}

void InspCls::newMode(int m) {
int n;

mode=m;

switch (mode) {
case CLS_CLASSES:
	n=fileCount(filespec)/2;
	imgn->setRange(0,n-1);
	imgn->show();
	imgn2->hide();
	imgn->setValue(0);
	if (n>1) imgn2->setValue(1);
	MMode->setCurrentItem(1);
	newMidMode(1);
	break;
case CLS_CLS:
	n=fileCount(filespec);
	imgn->hide();
	imgn2->show();
	imgn2->setRange(n>1?1:0,n-1);
	imgn->setValue(0);
	if (n>1) imgn2->setValue(1);
	MMode->setCurrentItem(1);
	newMidMode(1);
	break;
case CLS_GEN:
	n=fileCount(filespec);
	imgn->show();
	imgn2->show();
	imgn->setRange(0,n-1);
	imgn2->setRange(0,n-1);
	imgn->setValue(0);
	if (n>1) imgn2->setValue(1);	
	MMode->setCurrentItem(0);
	newMidMode(0);
	break;
}

}

void InspCls::newMidMode(int m) {
mmode=m;

switch (mmode) {
case DIFF:
	break;
case DIFFA:
	break;
case SWAP:
	break;

}
update(0);
}

void InspCls::newNormsel(int m) {
nsel=m;

update(0);
}


void InspCls::go() {
if (mmode==CCL) {
	swap++;
	swap=swap%3;
	update(0);
	return;
}

swap^=1;
update(0);
}

void InspCls::update(int n) {
EMData *tmp;
int n1,n2;

n1=imgn->value();
n2=imgn2->value();

if (mode==CLS_CLASSES) {
	im1->readImage(filespec,n1*2);
	if (im3->readImage(filespec,n1*2+1)) im3->readImage(filespec,n1*2);
}
else {
	im1->readImage(filespec,n1);
	if (im3->readImage(filespec,n2)) im3->readImage(filespec,n1);
}

switch (nsel) {
case 0: break;
case 1:
	im1->edgeNormalize();
	im3->edgeNormalize();
	break;
case 2:
	im1->normalize();
	im3->normalize();
	break;
case 3:
	im3->edgeNormalize();
//	im3->edgeNormalize();
//	im1->normalize();
//	im3->normalize();
//	float f=im3->dCenter();
//	im3->addConst(-f);
	if (mmode!=DIFFA) im1->normalizeTo(im3,1);
	break;
}

switch (mmode) {
case DIFFA:
//	tmp=im3->RTFAlignSlow(im1,NULL,im3->xSize()/10);
	tmp=im3->RTFAlign(im1,NULL,0);
//	tmp=im3->RTFAlignRadon(im1);
	tmp->refineAlign(im1,1);
	printf("Alignment %1.2f,%1.2f  %1.2f\n",tmp->Dx(),tmp->Dy(),tmp->alt()*180./PI);
	delete im3;
	im3=tmp;
	if (nsel==3) {
//		im3->edgeNormalize();
		im1->normalizeTo(im3,1);
	}
case DIFF:
	delete im2;
	im2=im3->copy(0,0);
//	im2->normalizeTo(im3);
	im2->subtract(im1);
	printf("Sigma=%f  %f  %f\tMean=%f\tSigD=%f\n",im1->Sigma(),im2->Sigma(),im3->Sigma(),im2->Mean(),im2->sigDiff());
	break;
case SWAP:
	if (swap) { delete im2; im2=im3->copy(0,0); golabel->setText("-->"); }
	else { delete im2; im2=im1->copy(0,0); golabel->setText("<--"); }
	break;
case CCF:
	delete im2;
	im2=im1->calcCCF(im3);
	im2->toCorner();
	break;
case RCCF:
	delete im2;
	if (swap) { im2=im3->makeRFP()->copy(); golabel->setText("-->"); }
	else { im2=im1->makeRFP()->copy(); golabel->setText("<--"); }
	break;
case RCCF2:
	delete im2;
	if (swap) { im2=im3->makeRFP(0,0)->copy(); golabel->setText("-->"); }
	else { im2=im1->makeRFP(0,0)->copy(); golabel->setText("<--"); }
	break;
case RADON:
	delete im2;
	if (swap) { im2=im3->doRadon(); golabel->setText("-->"); }
	else { im2=im1->doRadon(); golabel->setText("<--"); }
	break;
case CCL:
	im1->edgeNormalize();
	im1->applyMask(-1,4);
	im3->edgeNormalize();
	im3->applyMask(-1,4);
	if (swap==0) {
		im2->commonLinesR(im1,im3,70,1);
		golabel->setText("Real");
	}
	else if (swap==1) {
		im1->toCorner();
		im3->toCorner();
		im2->commonLines(im1,im3,1,70,1);
		im2->multConst(-1.0/90.0);
		im1->toCorner();
		im3->toCorner();
		golabel->setText("FPR");
	}
	else {
		im1->toCorner();
		im3->toCorner();
		im2->commonLines(im1,im3,2,70,1);
		im1->toCorner();
		im3->toCorner();
		golabel->setText("FADot");
	}
	break;
case CCFX:
	delete im2;
	if (!im1->isComplexX()) {
		im1->xNormalize();
		im3->xNormalize();
	}
	im2=im1->calcCCFX(im3,5,im1->ySize()-1,1);
//	im2->edgeNormalize();
	break;
}

image1->setData(im1);
image2->setData(im2);
image3->setData(im3);

}
