#include "PyEMDataWrap.h"
#include "PyEMData.h"
#include "PyEuler.h"
#include "PyVect.h"
#include "PyPickle.h"
#include <boost/python.hpp>
#include <boost/python/to_python_converter.hpp>

namespace python = boost::python;

BOOST_PYTHON_FUNCTION_OVERLOADS(readImages_overloads, py_readImages, 3, 4);
BOOST_PYTHON_FUNCTION_OVERLOADS(readImagesExt_overloads, py_readImagesExt, 4, 5);

BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_copy, py_copy, 0, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_readImage, readImage, 1, 4);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_writeImage, writeImage, 1, 6);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_BilateralFilter, BilateralFilter, 2, 4);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_calcHist, py_calcHist, 2, 5);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_setSize, setSize, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_setRAlign, setRAlign, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_setTAlign, setTAlign, 2, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_calcCCF, py_calcCCF, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_calcFLCF, py_calcFLCF, 2, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_calcCCFX, py_calcCCFX, 1, 4);

BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_calcMCF, py_calcMCF, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_littleBigDot, py_littleBigDot, 1, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_rotAlignCH, rotAlignCH, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_transAlign3d, transAlign3d, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_RTFAlignRadon, py_RTFAlignRadon, 1, 6);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_RTAlignRadon, py_RTAlignRadon, 1, 4);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_RTFAlignSlow, py_RTFAlignSlow, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_RTFAlignSlowest, py_RTFAlignSlowest, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_RTFAlignBest, py_RTFAlignBest, 0, 4);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_RTFAlign, py_RTFAlign, 0, 4);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_refineAlign, refineAlign, 1, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_makeRFP, py_makeRFP, 0, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_unwrap, py_unwrap, 0, 6);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_rotateAndTranslate, rotateAndTranslate, 0, 5);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_rotateAndTranslateFast, rotateAndTranslateFast, 0, 1);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_fastTranslate, fastTranslate, 0, 1);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_cmCenter, cmCenter, 0, 1);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_applyMask, applyMask, 2, 5);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_autoMask, autoMask, 1, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_applyRadFn, py_applyRadFn, 4, 5);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_normalizeTo, py_normalizeTo, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_edgeNormalize, edgeNormalize, 0, 1);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_xNormalize, xNormalize, 0, 1);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_leastSquareNormalizeTo, py_leastSquareNormalizeTo, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_maskNormalize, maskNormalize, 1, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_dotRT, dotRT, 4, 4);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_dot, dot, 1, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_lcmp, py_lcmp, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_realFilter, realFilter, 1, 4);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_makeAverage, py_makeAverage, 1, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_makeAverageCTFCWauto, py_makeAverageCTFCWauto, 1, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_makeAverageCTFCW, py_makeAverageCTFCW, 2, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_mult, mult, 1, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_commonLines, commonLines, 2, 5);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_project3d, py_project3d, 4, 5);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_commonLinesR, commonLinesR, 2, 4);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_fftSlice, py_fftSlice, 3, 4);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_setup4Slice, setup4Slice, 0, 1);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_insertSlice, insertSlice, 4, 6);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_doneSlice, doneSlice, 0, 1);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_doneSliceWF, doneSliceWF, 0, 1);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_cutSlice, cutSlice, 2, 6);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_uncutSlice, uncutSlice, 2, 5);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_ctfMap, ctfMap, 1, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_dist, dist, 1, 2);



void export_EMData()
{
    python::class_<EMData> EMData_class("_EMData", "Don't use this class. Use EMData instead.");
    EMData_class.def(python::init<>());
    
    python::class_<PyEMData, python::bases<EMData> > PyEMData_class("EMData", "EMData() \n  construct an empty EMData instance");
    PyEMData_class.def(python::init<>());

    PyEMData_class.def("getData", &PyEMData::get_num_array, "Numeric.array getData()");
    PyEMData_class.def("setData", &PyEMData::set_num_array, "void setData(Numeric.array array)");

    
    PyEMData_class.def("copyHead", &PyEMData::py_copyHead,
		       python::return_value_policy<python::manage_new_object>(),
		       "EMData copyHead() \n copies descriptive information without any real data");
    
    PyEMData_class.def("copy", &PyEMData::py_copy,
		       EMData_py_copy("EMData copy(int withfft=0, int withparent=1)\n  returns an exact copy of itself")
		       [python::return_value_policy<python::manage_new_object>()]);

    PyEMData_class.def("clip", (PyEMData* (PyEMData::*)(int, int, int, int)) &PyEMData::py_clip,
		       python::return_value_policy<python::manage_new_object>(),
		       "EMData clip(int x0, int y0, int xsize, int ysize) \nEMData clip(int x0, int y0, int z0, int xsize, int ysize, int zsize) \n  inclusive clip. Pads if larger than data");
    
    PyEMData_class.def("clip", (PyEMData* (PyEMData::*)(int, int, int, int, int, int)) &PyEMData::py_clip,
		       python::return_value_policy<python::manage_new_object>(),
		       "EMData clip(int x0, int y0, int xsize, int ysize) \nEMData clip(int x0, int y0, int z0, int xsize, int ysize, int zsize) \n  inclusive clip. Pads if larger than data");
    
    EMData_class.def("insertClip", &EMData::insertClip, 
		     "insertClip(EMData block, int x0, int y0) \n used for 2D only");
    
    EMData_class.def("readMRCArea", (int (EMData::*)(const char *fsp,int x0,int y0,int w,int h))&EMData::readMRCArea,
		     "int readMRCArea(string fsp, int x0, int y0, int xsize, int ysize) \n  read a rectangular area from a mrc file. works ONLY for real 2d images. Also the area MUST reside within the image. \n\nint readMRCArea(string fsp, int x0, int y0, int z0, int xsize, int ysize, int zsize) \n  read a cube from a 3D mrc file. works ONLY for real 3d images. Also the area MUST reside within the image.");
    
    EMData_class.def("readMRCArea", (int (EMData::*)(const char *fsp,int x0,int y0,int z0,int xl,int yl,int zl))&EMData::readMRCArea,
		     "int readMRCArea(string fsp, int x0, int y0, int xsize, int ysize) \n  read a rectangular area from a mrc file. works ONLY for real 2d images. Also the area MUST reside within the image. \n\nint readMRCArea(string fsp, int x0, int y0, int z0, int xsize, int ysize, int zsize) \n  read a cube from a 3D mrc file. works ONLY for real 3d images. Also the area MUST reside within the image.");
    

    EMData_class.def("readImage", (int (PyEMData::*)(const char*, int, int, ImageType)) &PyEMData::readImage,
		     EMData_readImage(python::args("filename", "n", "nodata", "imagetype"), "int readImage(filename, n = 0, nodata = 0, imagetype = EMData.ANY) \n  Reads a single image from a file. If image type is not specified, the image type will be determined from file type. return 0 if succeeds; return -1 if fails."));
    
    EMData_class.def("writeImage", (int (PyEMData::*)(const char*, int, ImageType, int, int, int)) &PyEMData::writeImage,
		     EMData_writeImage(python::args("filename", "n", "imagetype", "nolock", "swap", "mode"),"int writeImage(filename, n=0, imagetype=EMData.ANY, nolock=0, swap = 0, mode=MODE_float) \n  Writes a single image to a file. If image type is not specified, teh image type will be determined from given file type. return 0 if succeeds; return -1 if fails."));

    python::def("fileCount", (python::tuple (*)(const char*)) fileCount, "tuple fileCount(string imagefile) \n Returns a tuple with the number of images in a file and the image type.");

    python::def("readImages", py_readImages,
		readImages_overloads("list readImages(string imagefile, int n0, int n1, int nodata=0) \n  Read a set of images. return a list of EMData instances ranging from image n0 to image n1. If nodata is 0, only read image header information. If nodata is 1, read both image data and image header."));

    python::def("readImagesExt", py_readImagesExt,
		readImagesExt_overloads("list readImagesExt(string imagefile, string ext, int n0, int n1, int nodata=0) \n  Read a set of filtered images with an automatically generated filename. return a list of EMData instances ranging from image n0 to image n1. If nodata is 0, only read image header information. If nodata is 1, read both image data and image header."));

    
    EMData_class.def("readLST", &EMData::readLST, "int readLST(string filespec, int n, int nodata=0, string file_ext = None) \n  writes a pointer to an image file to a LST file");
    
    EMData_class.def("writeLST", &EMData::writeLST,
		     "int writeLST(string filespec, int n, string reffile, int refn, string comment)");
    
    EMData_class.def("serialIn", &EMData::serialIn, "serialIn(int file_descriptor)");
    
    EMData_class.def("serialOut", &EMData::serialOut, 
		     "serialOut(int file_descriptor) \n  used ONLY for FILESERVER operation, not safe otherwise");
    
    EMData_class.def("writeDebug", &EMData::writeDebug,
		     "writeDebug(int n) \n  write to a special graphical debug viewer");
    
    EMData_class.def("BilateralFilter", (void (EMData::*)(float, float, int, int)) &EMData::BilateralFilter,
		     EMData_BilateralFilter("void BilateralFilter(float sigma1, float sigma2, int iter=1, int localWidth=1);"));

    EMData_class.def("calcHist", &PyEMData::py_calcHist,
		     EMData_calcHist("calcHist(list hist, int n, float hmin=0, float hmax=0, int add=0)"));

    EMData_class.def("update", &EMData::update, 
		     "update() \n  Tells EMData to update itself in the future.");
    
    EMData_class.def("setPixel", &EMData::setPixel, 
		     "setPixel(float pix) \n  set the pixel value.");
    EMData_class.def("Pixel", &EMData::Pixel, 
		     "float Pixel() \n  returns the pixel value.");

    EMData_class.def("Min", &EMData::Min,
		     "float Min()");
    EMData_class.def("Max", &EMData::Max,
		     "float Max()");
    PyEMData_class.def("MinLoc", &PyEMData::py_MinLoc, 
		       "tuple MinLoc() \n  Returns minimum value locations in a tuple with (min_x_loc, min_y_loc, min_z_loc)");
    PyEMData_class.def("MaxLoc", &PyEMData::py_MaxLoc, 
		       "tuple MaxLoc() \n  Returns maxium value locations in a tuple with (max_x_loc, max_y_loc, max_z_loc)");

    PyEMData_class.def("display", &PyEMData::display, 
		       "int display() \n  Display the current image. Returns 0 if success; Returns -1 on error.");    
    EMData_class.def("Mean", &EMData::Mean, 
		     "float Mean()");
    EMData_class.def("Sigma", &EMData::Sigma, 
		     "float Sigma()");
    EMData_class.def("SumSq", &EMData::SumSq, 
		     "float SumSq()");
    EMData_class.def("Mean2", &EMData::Mean2, 
		     "float Mean2()");
    EMData_class.def("Sigma2", &EMData::Sigma2, 
		     "float Sigma2()");
    EMData_class.def("Skewness", &EMData::Skewness, 
		     "float Skewness()");
    EMData_class.def("Kurtosis", &EMData::Kurtosis, 
		     "float Kurtosis()");      
    EMData_class.def("edgeMean", &EMData::edgeMean, 
		     "float edgeMean()");
    EMData_class.def("cirMean", &EMData::cirMean, 
		     "float cirMean()");
    EMData_class.def("setParent", &EMData::setParent, 
		     "setParent(EMData data)");
    PyEMData_class.def("Parent", &PyEMData::py_Parent,
		       python::return_internal_reference<>(),
		       "EMData Parent()");
    EMData_class.def("setName", &EMData::setName, 
		     "setName(string name)");
    EMData_class.def("Name", &EMData::Name, 
		     "string Name()");
    EMData_class.def("setPath", &EMData::setPath, 
		     "setPath(string path)");
    EMData_class.def("Path", &EMData::Path, 
		     "string Path()");
    EMData_class.def("setPathN", &EMData::setPathN, 
		     "setPathN(int n)");
    EMData_class.def("PathN", &EMData::PathN, 
		     "int PathN()");

    EMData_class.def("xSize", &EMData::xSize, 
		     "int xSize() \n  Returns x dimension size");
    EMData_class.def("ySize", &EMData::ySize, 
		     "int ySize()  \n  Returns y dimension size");
    EMData_class.def("zSize", &EMData::zSize, 
		     "int zSize() \n  Returns z dimension size");
    EMData_class.def("setSize", &EMData::setSize, 
		     EMData_setSize("int setSize(int x, int y=1, int z=1) \n Sets x, y, z dimension sizes"));
    EMData_class.def("setRI", &EMData::setRI, 
		     "setRI(int i)");
    EMData_class.def("setComplex", &EMData::setComplex, 
		     "setComplex(int i)");
    EMData_class.def("isComplex", &EMData::isComplex, 
		     "int isComplex() \n Returns 1 if the data is in complex number mode; Returns 0 othewise.");
    EMData_class.def("setComplexX", &EMData::setComplexX, 
		     "setComplexX(int i)");
    EMData_class.def("isComplexX", &EMData::isComplexX,
		     "int isComplexX()");
    EMData_class.def("hasCTF", &EMData::hasCTF,
		     "int hasCTF()");
    EMData_class.def("hasCTFF", &EMData::hasCTFF,
		     "int hasCTFF()");
    EMData_class.def("getFlags", &EMData::getFlags, 
		     "int getFlags()");
    EMData_class.def("aliPeak", &EMData::aliPeak, 
		     "float aliPeak()");
    EMData_class.def("setFlipped", &EMData::setFlipped, 
		     "setFlipped(int f)");
    EMData_class.def("isFlipped", &EMData::isFlipped, 
		     "int isFlipped()");
    EMData_class.def("Dx", &EMData::Dx,  
		     "float Dx()");
    EMData_class.def("Dy", &EMData::Dy, 
		     "float Dy()");
    EMData_class.def("Dz", &EMData::Dz, 
		     "float Dz()");
    EMData_class.def("alt", &EMData::alt, 
		     "float alt()");
    EMData_class.def("az", &EMData::az, 
		     "float az()");
    EMData_class.def("phi", &EMData::phi, 
		     "float phi()");
    PyEMData_class.def("getEuler", &PyEMData::py_getEuler,
		       python::return_internal_reference<>(),
		       "Euler getEuler()");

    EMData_class.def("setTAlign", &EMData::setTAlign,
		     EMData_setTAlign("setTAlign(float x, float y, float z=0)"));
    
    EMData_class.def("setRAlign", (void (EMData::*)(Euler*))&EMData::setRAlign,
		     "setRAlign(Euler angle)");
    
    EMData_class.def("setRAlign", (void (EMData::*)(float, float, float))&EMData::setRAlign,
		     EMData_setRAlign("setRAlign(float Alt, float Az=0, float Phi=0)"));

    EMData_class.def("NImg", &EMData::NImg, 
		     "int NImg() \n  Returns the number images in this image file.");
    
    EMData_class.def("getATime", &EMData::getATime, 
		     "long getATime() \n  Returns access time for the image file.");
    
    EMData_class.def("getImagicHed", &EMData::getImagicHed,
		     python::return_internal_reference<>(),
		     "imagicH getImagicHed()");
    EMData_class.def("setImagicHed", &EMData::setImagicHed, 
		     "setImagicHed(imagicH hed)");
    EMData_class.def("getMRCHed", &EMData::getMRCHed,
		     python::return_internal_reference<>(),
		     "mrcH getMRCHed()");
    EMData_class.def("getSpiHed", &EMData::getSpiHed,
		     python::return_internal_reference<>(),
		     "SPIDERH getSpiHed() \n  Returns the header of a spider image.");
    
    EMData_class.def("Busy", &EMData::Busy, "int Busy() \n  Returns 1 if data is checked out");

    EMData_class.def("waitReady", &EMData::waitReady,
		     "int waitReady(int readonly) \n  Waits for data to become available; Returns 0 if OK; Returns non-zero if any error.");
    
    EMData_class.def("Wait", &EMData::Wait, "Wait() \n  Waits until the data becomes available.");
    
    EMData_class.def("swapout", &EMData::swapout, "int swapout() \n  Swaps the data out to a temporary file.");

    EMData_class.def("swapin", &EMData::swapin, "int swapin() \n  Swaps the data in from the swap file.");

    EMData_class.def("zero", &EMData::zero, 
		     "zero() \n  Sets all the data values to be 0.");
    EMData_class.def("one", &EMData::one, 
		     "one() \n  Sets all the data values to be 1.");
    
    EMData_class.def("ri2ap", &EMData::ri2ap, 
		     "ri2ap() \n  converts real/imaginary to amp/pha (complex only)");
    EMData_class.def("ap2ri", &EMData::ap2ri, 
		     "ap2ri() \n  converts amp/pha to real/imaginary (complex only)");
    PyEMData_class.def("doFFT", &PyEMData::py_doFFT,
		       python::return_value_policy<python::manage_new_object>(),
		       "EMData doFFT() \n  Apply fourier transform on the data.");
    
    PyEMData_class.def("doIFT", &PyEMData::py_doIFT,
		       python::return_value_policy<python::manage_new_object>(),
		       "EMData doIFT() \n  Apply inverse fourier transform on the data.");
    
    EMData_class.def("gimmeFFT", &EMData::gimmeFFT, 
		     "gimmeFFT() \n  gives the caller ownership of the recently obtained fourier transform, so it won't be freed automatically");
    PyEMData_class.def("doRadon", &PyEMData::py_doRadon,
		       python::return_value_policy<python::manage_new_object>(),
		       " EMData doRadon() \n  Radon transform of image, comes out square");
    PyEMData_class.def("vertACF", &PyEMData::py_vertACF,
		       python::return_value_policy<python::manage_new_object>(),
		       "EMData vertACF(int maxdy) \n  vertical autocorrelation calculated in real-space over a range of translations");
    EMData_class.def("doDWT", &EMData::doDWT, 
		     "doDWT(int basis, int level) \n  in place DWT, basis/level defined elsewhere");
    EMData_class.def("doIWT", &EMData::doIWT, 
		     "doIWT(int basis, int level) \n  inverse wavelet x-form");
    EMData_class.def("DWTFilt", &EMData::DWTFilt, 
		     "DWTFilt(int basis, int level, float thresh) \n  in place nonlinear threshold wavelet filter. thresh is with respect to the 'ideal' threshold");

    PyEMData_class.def("convolute", &PyEMData::py_convolute,
		       python::return_value_policy<python::manage_new_object>(),
		       "EMData convolute(EMData with)");
    PyEMData_class.def("calcCCF", &PyEMData::py_calcCCF,
		       EMData_py_calcCCF("EMData calcCCF(EMData with, int tozero, EMData filter=None) \n  cross correlation between 2 images")
		       [python::return_value_policy<python::manage_new_object>()]);
    PyEMData_class.def("calcFLCF", &PyEMData::py_calcFLCF,
		       EMData_py_calcFLCF("EMData calcFLCF(EMData with, int r) \n  locally normalized cross correlation between 2 images")
		       [python::return_value_policy<python::manage_new_object>()]);
    PyEMData_class.def("calcCCFX", &PyEMData::py_calcCCFX,
		       EMData_py_calcCCFX("EMData calcCCFX(EMData with, int y0=0, int y1=-1, int nosum=0) \n  calculates sum of x-axis CCFs")
		       [python::return_value_policy<python::manage_new_object>()]);
    PyEMData_class.def("calcMCF", &PyEMData::py_calcMCF,
		       EMData_py_calcMCF("EMData calcMCF(EMData with, int tocorner, EMData filter=None) \n  mutual correlation between 2 images")
		       [python::return_value_policy<python::manage_new_object>()]);
    
    PyEMData_class.def("littleBigDot", &PyEMData::py_littleBigDot,
		       EMData_py_littleBigDot("EMData littleBigDot(EMData with, int sigma=0) \n  CCF in real-space, designed for cases where with is small")
		       [python::return_value_policy<python::manage_new_object>()]);
    
    EMData_class.def("transAlign", &PyEMData::py_transAlign, 
		     "tuple transAlign(EMData with, int useparent, int intonly, int maxshift)  \n  translational alignment using CCF");
    EMData_class.def("rotAlign", &EMData::rotAlign, 
		     "float rotAlign(EMData with) \n  rotational alignment using angular correlation");
    EMData_class.def("rotAlignPrecen", &EMData::rotAlignPrecen, 
		     "float rotAlignPrecen(EMData with) \n  rotational alignment assuming centers are correct");
    EMData_class.def("rotAlignCH", &EMData::rotAlignCH, 
		     EMData_rotAlignCH("float rotAlignCH(EMData with, int irad=8, int orad=0) \n  rotational alignment via circular harmonic"));
    EMData_class.def("transAlign3d", &EMData::transAlign3d, 
		     EMData_transAlign3d("float transAlign3d(EMData with,int useparent=0,int intonly=0) \n  translational alignment using CCF"));
    PyEMData_class.def("RTFAlignRadon", &PyEMData::py_RTFAlignRadon,
		       EMData_py_RTFAlignRadon("EMData RTFAlignRadon(EMData with,int maxshift=-1,EMData thisf=None,EMData radonwith=None ,EMData radonthis=None,EMData radonthisf=None) \n  rotational, translational and flip alignment with Radon transforms")
		       [python::return_value_policy<python::manage_new_object>()]);

    PyEMData_class.def("RTAlignRadon", &PyEMData::py_RTAlignRadon,
		       EMData_py_RTAlignRadon("EMData RTAlignRadon(EMData with,int maxshift=-1,EMData radonwith=None,EMData radonthis=None)")
		       [python::return_value_policy<python::manage_new_object>()]);
    
    PyEMData_class.def("RTFAlignSlow", &PyEMData::py_RTFAlignSlow,		     
		       EMData_py_RTFAlignSlow("EMData RTFAlignSlow(EMData with,EMData flip=None,int maxshift=-1)\n  rotational, translational and flip alignment using real-space methods, SLOW")
		       [python::return_value_policy<python::manage_new_object>()]);
    
    PyEMData_class.def("RTFAlignSlowest", &PyEMData::py_RTFAlignSlowest,		     
		       EMData_py_RTFAlignSlowest("EMData RTFAlignSlowest(EMData with,EMData flip=None,int maxshift=-1)\n  rotational, translational and flip alignment using exhaustive search. VERY SLOW")
		       [python::return_value_policy<python::manage_new_object>()]);
    
    PyEMData_class.def("RTFAlignBest", &PyEMData::py_RTFAlignBest,
		       EMData_py_RTFAlignBest("EMData RTFAlignBest(EMData with=None,EMData flip=None,int maxshift=-1,float *snr) \n  rotational, translational and flip alignment")
		       [python::return_value_policy<python::manage_new_object>()]);

    PyEMData_class.def("RTFAlign", &PyEMData::py_RTFAlign,
		       EMData_py_RTFAlign("EMData RTFAlign(EMData with=None,EMData flip=None,int usedot=1,int maxshift=-1) \n  rotational, translational and flip alignment")
		       [python::return_value_policy<python::manage_new_object>()]);

    PyEMData_class.def("RTAlignBest", &PyEMData::py_RTAlignBest,
		       python::return_value_policy<python::manage_new_object>(),
		       "EMData RTAlignBest(EMData with, int maxshift=0, float *snr)");

    PyEMData_class.def("RTAlign", &PyEMData::py_RTAlign,
		       python::return_value_policy<python::manage_new_object>(),
		       "EMData RTAlign(EMData with, int usedot=0, int maxshift=0)");

    EMData_class.def("refineAlign", &EMData::refineAlign, 
		     EMData_refineAlign("refineAlign(EMData with,int mode=1)"));
    
    PyEMData_class.def("makeRFP", &PyEMData::py_makeRFP,
		       EMData_py_makeRFP("EMData makeRFP(int premasked=0,int unwrap=1)\n  Makes a 'rotational footprint', which is an 'unwound' autocorrelation function. if unwrap is 0 the rfp is not cached. generally the image should be edgenormalized and masked before using this")
		       [python::return_internal_reference<>()]);
    
    PyEMData_class.def("unwrap", &PyEMData::py_unwrap,
		       EMData_py_unwrap("EMData unwrap(int r1=-1,int r2=-1,int xs=-1,int dx=0,int dy=0,int do360=0)\n  maps polar coordinates to cylindrical coordinates")
		       [python::return_value_policy<python::manage_new_object>()]);
    
    EMData_class.def("calcRCF", &PyEMData::py_calcRCF, 
		     "calcRCF(EMData with, list sum,int NS)");
    
    EMData_class.def("rotateX", &EMData::rotateX, 
		     "rotateX(int dx) \n  This performs a translation of each line along x with wraparound this is equivalent to a rotation when performed on 'unwrapped' maps");
    
    EMData_class.def("rotateAndTranslate", &EMData::rotateAndTranslate, 
		     EMData_rotateAndTranslate("rotateAndTranslate(float scale=1.0,float dxc=0,float dyc=0,float dzc=0,int r=0)"));
    EMData_class.def("rotateAndTranslateFast", &EMData::rotateAndTranslateFast, 
		     EMData_rotateAndTranslateFast("rotateAndTranslateFast(float scale=1.0)\n  rotate and translate using current settings behavior changes if parent is/not set"));

    EMData_class.def("fastTranslate", &EMData::fastTranslate, 
		     EMData_fastTranslate("fastTranslate(int inplace=1)\n  fast integer-only translation"));
    EMData_class.def("rot180", &EMData::rot180, 
		     "rot180()\n  fast rotation by 180 degrees");
    EMData_class.def("cmCenter", &EMData::cmCenter, 
		     EMData_cmCenter("cmCenter(int intonly=1)\n  center at center of mass, ignores old dx,dy"));
    EMData_class.def("applyMask", &EMData::applyMask, 
		     EMData_applyMask("applyMask(int r,int type)\n  applies a circular mask to the data. type=0 is a step cutoff to the mean value type=4 is a step cutoff to zero type=1 fills in with flatband random noise"));
    EMData_class.def("autoMask", &EMData::autoMask, 
		     EMData_autoMask("autoMask(float thresh,float filter=.1) \n  Attempts to automatically mask out the particle, excluding other particles in the box, etc. thresh runs from ~ -2 to 2, negative numbers for dark. protien and positive numbers for light protein (stain) filter is expressed as a fraction of the Fourier radius "));
    EMData_class.def("applyRadFn", &PyEMData::py_applyRadFn, 
		     EMData_applyRadFn("applyRadFn(int n,float x0,float dx, list y,int interp=1)"));
    EMData_class.def("addRadNoise", &PyEMData::py_addRadNoise, 
		     "addRadNoise(int n, float x0, float dx, list y, int interp)");
    EMData_class.def("subtract", &EMData::subtract, 
		     "subtract(EMData data) \n  subtracts 'data' from the current set");
    EMData_class.def("vFlip", &EMData::vFlip, 
		     "vFlip()\n  flips image vertically");
    EMData_class.def("hFlip", &EMData::hFlip, 
		     "hFlip()\n  flips image horizontally");
    EMData_class.def("normalize", &EMData::normalize, 
		     "normalize()\n  mean -> 0, std dev -> 1");
    EMData_class.def("normalizeTo", &PyEMData::py_normalizeTo, 
		     EMData_normalizeTo("tuple normalizeTo(EMData noisy,int keepzero=0,int invert=0)\n  This will multiply 'this' by a constant so. it is scaled to the signal in 'to'keepzero will exclude zero values, and keep them at zero in the result"));
    EMData_class.def("normalizeMax", &EMData::normalizeMax, 
		     "normalizeMax()\n  mean -> 0, std dev -> 1");
    EMData_class.def("edgeNormalize", &EMData::edgeNormalize, 
		     EMData_edgeNormalize("edgeNormalize(int cir=0)\n  normalizes so mean -> value at edge of image, if cir=1, uses 2 pixel circular border"));
    EMData_class.def("xNormalize", &EMData::xNormalize, 
		     EMData_xNormalize("xNormalize(int mode=0)\n  normalizes each row in the image individually"));
    EMData_class.def("addMaskShell", &EMData::addMaskShell, 
		     "addMaskShell(int shells)\n  Will add additional shells/rings to an existing 1/0 mask image");
    EMData_class.def("leastSquareNormalizeTo", &PyEMData::py_leastSquareNormalizeTo, 
		     EMData_leastSquareNormalizeTo("tuple leastSquareNormalizeTo(EMData to, float low_thresh=FLT_MIN, float high_thresh=FLT_MAX)"));
    EMData_class.def("maskNormalize", &EMData::maskNormalize, 
		     EMData_maskNormalize("maskNormalize(EMData mask,int sigmatoo=1)\n  Uses a 1/0 mask defining a region to use for the zero-normalization, if sigma is 0, std-dev not modified"));
    EMData_class.def("invert", &EMData::invert, 
		     "invert()\n  multiply by -1");
    EMData_class.def("calcRadDist", (void (PyEMData::*)(int, float, float, PyList))&PyEMData::py_calcRadDist, 
		     "calcRadDist(int n,float x0,float dx, list y)");
    EMData_class.def("calcRadDist", (void (PyEMData::*)(int, float, float, PyList, float, float))&PyEMData::py_calcRadDist, 
		     "calcRadDist(int n,float x0,float dx, list y)");

    EMData_class.def("calcAzDist", &PyEMData::py_calcAzDist, 
		     "calcAzDist(int n,float a0,float da, list data,float rmin,float rmax)");
    EMData_class.def("radialAverage", &EMData::radialAverage, 
		     "radialAverage()\n  makes image circularly symmetric");
    EMData_class.def("radialSubtract", &EMData::radialSubtract, 
		     "radialSubtract()\n  subtracts circularly symmetric part of image");
    EMData_class.def("toCorner", &EMData::toCorner,
		     "toCorner \n Translates a centered image to the corner");

    EMData_class.def("dotRT", &EMData::dotRT,
		     EMData_dotRT("float dot(EMData data,float dx,float dy,float da)\n  dot product of 2 images with 'this' rotated and translated (same size !). MUCH faster than RotateAndTranslate() followed by dot()."));
    EMData_class.def("dot", &EMData::dot,
		     EMData_dot("float dot(EMData data,int evenonly=0)\n  dot product of 2 images (same size !)"));
    EMData_class.def("lcmp", &PyEMData::py_lcmp,
		     EMData_lcmp("tuple lcmp(EMData noisy,int keepzero=0,int invert=0)\n  linear comparison of 2 data sets (smaller better)"));
    EMData_class.def("pcmp"  , &EMData::pcmp,
		     "float pcmp(EMData data, XYData snr=None) \n  amplitude weighted mean phase error, 'data' should be less noisy than 'this' pcmp");
    EMData_class.def("fscmp", &EMData::fscmp, 
		     " float fscmp(EMData with)\n  returns a quality factor based on FSC between images larger numbers indicate a better match");
    
    EMData_class.def("dCenter", &EMData::dCenter, 
		     "float dCenter()\n  This will find the density value at the peak of the image histogram, sort of like the mode of the density");
    EMData_class.def("sigDiff", &EMData::sigDiff, 
		     "float sigDiff()\n  Calculates sigma above and below the mean and returns the difference between them");
    EMData_class.def("realFilter", &EMData::realFilter, 
		     EMData_realFilter("realFilter(int type, float val1=0,float val2=0, float val3=0)\n  a variety of real-space filters"));
    EMData_class.def("filter", &EMData::filter, 
		     "filter(float highpass,float lowpass,int type)\n  fourier filters an image, real or imaginary");
    EMData_class.def("makeAverage", &PyEMData::py_makeAverage, 
		     EMData_makeAverage("makeAverage(list in,EMData sigma=None)\n  averages the images in the list, result in 'this' optionally makes a sigma image as well"));
    EMData_class.def("makeAverageIter", &PyEMData::py_makeAverageIter, 
		     "makeAverageIter(list in)");
    EMData_class.def("makeAverageWT", &PyEMData::py_makeAverageWT, 
		     "makeAverageWT(list in,EMData curves,XYData sf)\n  averages the images in the list with SNR weightingbut no CTF correction");
    EMData_class.def("makeAverageCTFC", &PyEMData::py_makeAverageCTFC, 
		     "makeAverageCTFC(list in,float filtr)\n  averages the images in the list with CTF correction filtr is in angstroms,");
    EMData_class.def("makeAverageCTFCWauto", &PyEMData::py_makeAverageCTFCWauto, 
		     EMData_makeAverageCTFCWauto("makeAverageCTFCWauto(list in, string outfile=None)\n  This does CTF correction with a Wiener filter where the filter is estimated directly from the data"));
    EMData_class.def("makeAverageCTFCW", &PyEMData::py_makeAverageCTFCW, 
		     EMData_makeAverageCTFCW("makeAverageCTFCW(list in, XYData sf, list SNR=None)\n  averages the images in the list with CTF correction"));
    EMData_class.def("makeMedian", &PyEMData::py_makeMedian, 
		     "makeMedian(list in)\n  Median of the images in the list, result in 'this'");

    EMData_class.def("add", (void (EMData::*)(EMData*))&EMData::add, 
		     "add(EMData in)\n  adds 'in' to 'this'");

    EMData_class.def("add", (void (EMData::*)(float))&EMData::add, 
		     "add(float d)\n  add const number to each element");

    EMData_class.def("addIncoherent", &EMData::addIncoherent, 
		     "addIncoherent(EMData in)\n  adds 'in' to 'this'");
    EMData_class.def("mult", &EMData::mult, 
		     EMData_mult("mult(EMData in,int recip=0)\n  multiplies 'in' by 'this', if recip, then divide"));
    EMData_class.def("multConst", &EMData::multConst, 
		     "multConst(float)\n  multiply by constant");
    EMData_class.def("addConst", &EMData::addConst, 
		     "addConst(float)\n add a constant");
    EMData_class.def("meanShrink", &EMData::meanShrink, 
		     " meanShrink(int i)\n  reduces the size of the image by a factor of i, using the average value of the pixels in a block");
    EMData_class.def("medianShrink", &EMData::medianShrink, 
		     "medianShrink(int i)\n  reduces the size of the image by a factor of i using a local median filter");
    EMData_class.def("commonLines", &EMData::commonLines, 
		     EMData_commonLines("commonLines(EMData d1,EMData d2,int mode=0,int steps=180,int horiz=0) \n  finds common lines between 2 complex images. mode 0 is a summed dot-product mode 1 is weighted phase residualsteps is 1/2 the resolution of the )map"));
    EMData_class.def("commonLinesR", &EMData::commonLinesR, 
		     EMData_commonLinesR("commonLinesR(EMData data1,EMData data2,int steps=180,int horiz=0)"));
    PyEMData_class.def("project3d", &PyEMData::py_project3d,		     
		       EMData_py_project3d("EMData project3d(float alt,float az, float phi, int mode, float thr=1.0) \n  makes a 3d projection of a volume, mode=-1 does real space projection, 1-5 use fftslice for fourier projection")
		       [python::return_value_policy<python::manage_new_object>()]);
    
    PyEMData_class.def("fftSlice", &PyEMData::py_fftSlice, 
		       EMData_py_fftSlice("EMData fftSlice(float alt,float az,float phi,int mode=5)\n  takes a slice from a 3d complex image for generating projections.")
		       [python::return_value_policy<python::manage_new_object>()]);
    
    EMData_class.def("setup4Slice", &EMData::setup4Slice, 
		     EMData_setup4Slice("setup4Slice(int redo=1)"));
    
    EMData_class.def("interpFT3d", &PyEMData::py_interpFT3d, 
		     "interpFT3d(float x,float y,float z, list ret,int mode)");
    
    EMData_class.def("setup4IS", &EMData::setup4IS, 
		     " setup4IS(int size)");
    EMData_class.def("normSlice", &PyEMData::py_normSlice, 
		     "tuple normSlice(EMData slice,float alt,float az,float phi)\n  try to make sure the slice is normalized properly");
    EMData_class.def("insertSlice", &EMData::insertSlice, 
		     EMData_insertSlice("insertSlice(EMData slice,  float alt,float az,float phi,int mode=5,float weight=1.0) \n  this inserts a complex slice into an image that has been setup4IS()"));
    EMData_class.def("insertSliceWF", &EMData::insertSliceWF, 
		     "insertSliceWF(EMData slice,  float alt,float az,float phi,int mode,list SNR,float padratio)\n  this inserts a complex slice into an image that has been setup4IS()");
    EMData_class.def("doneSlice", &EMData::doneSlice, 
		     EMData_doneSlice("doneSlice(int log=0)\n   once all of the slices have been added with insertSlice(), this routine does a normalization and returns a real 3d volume"));
    EMData_class.def("doneSliceWF", &EMData::doneSliceWF, 
		     EMData_doneSliceWF("doneSliceWF(int log=0)\n  It should only be used in conjunction with insertSliceWF"));
    EMData_class.def("insertSlice3DReal", &EMData::insertSlice3DReal, 
		     "insertSlice3DReal(EMData slice,float weight)");

    EMData_class.def("cutSlice", (void (EMData::*)(EMData*, float, Euler*, int, float, float))&EMData::cutSlice,
		     EMData_cutSlice("void cutSlice(EMData *map,float z,Euler *ort=NULL,int interp=1,float x=0,float y=0)\n  this will cut a slice out of a real 3D map"));

    EMData_class.def("uncutSlice", (void (EMData::*)(EMData*, float, Euler*, float, float))&EMData::uncutSlice,
		     EMData_uncutSlice("void uncutSlice(EMData *map,float z, Euler sort=NULL,float x=0,float y=0)\n  Opposite of cutSlice(). It will take a slice and insert the data into a real 3D map. It does not interpolate, it uses the nearest neighbor."));


    EMData_class.def("fsc", &PyEMData::py_fsc, "list fsc(EMData with); \n  returns the Fourier ring/shell correlation coef as an array with ysize/2 elements (corners not calculated).");
    
    EMData_class.def("ctfCurve", &PyEMData::py_ctfCurve, "list ctfCurve(int type=0, XYData sf=NULL)\n  Calculates a CTF curve. optional structure factor data for true SNR calc.");

    
    EMData_class.def("ctfMap", &EMData::ctfMap, 
		     EMData_ctfMap("ctfMap(int type, XYData sf=None)"));
    EMData_class.def("getCTF", &PyEMData::py_getCTF,
		     "list getCTF() \n  Returns the CTF parameters in a list.");

    EMData_class.def("setCTF", &PyEMData::py_setCTF, 
		     "setCTF(list new_ctf) \n  Sets CTF parameters with new values from a list. \n\nsetCTFF(string s) \n  Sets CTF parameters with new values from a string.");

    EMData_class.def("setCTFF", &EMData::setCTFF, 
		     "setCTF(list new_ctf) \n  Sets CTF parameters with new values from a list. \n\nsetCTFF(string s) \n  Sets CTF parameters with new values from a string.");
    
    EMData_class.def("clearCTF", &EMData::clearCTF, 
		     "clearCTF() \n  Clear CTF parameters.");
    
    EMData_class.def("CTFCmp", &EMData::CTFCmp, 
		     "int CTFCmp(EMData with)\n  used to detect if 2 images have the same CTF parameters");

    EMData_class.def("subNoise", &EMData::subNoise, 
		     "subNoise() \n  Subtract average noise from intensity. Negative results allowed.");

    PyEMData_class.def("iftSlice", &PyEMData::py_iftSlice,
		       python::return_value_policy<python::manage_new_object>(),
		       "EMData iftSlice()\n  This does an IFT of a volume reconstructed from slices. Includes a real-space correction for the linear interpolation in Fourier space");

    EMData_class.def("valueAt", (float (EMData::*)(int, int, int))&EMData::valueAt, 
		     "float valueAt(int x, int y) \n  Return data at a 2D position. \n\nfloat valueAt(int x, int y, int z) \n  Return data at a 3D position.");
    
    EMData_class.def("valueAt", (float (EMData::*)(int, int))&EMData::valueAt, 
		     "float valueAt(int x, int y) \n  Return a data value at a 2D position. It has no locking. \n\nfloat valueAt(int x, int y, int z) \n  Return a data value at a 3D position. It has no locking.");

    EMData_class.def("valueAtInterp", &EMData::valueAtInterp,
		     "float valueAtInterp(float x, float y) \n Returns a data value at a 2D position.");
    
    EMData_class.def("valueAtSafe", (float (EMData::*)(int, int, int))&EMData::valueAtSafe, 
		     "float valueAtSafe(int x, int y) \n  Return a data value at a 2D position. It has no locking. \n\nfloat valueAtSafe(int x, int y, int z) \n  Return a data value at a 3D position. It has no locking.");
    
    EMData_class.def("valueAtSafe", (float (EMData::*)(int, int))&EMData::valueAtSafe, 
		     "float valueAtSafe(int x, int y) \n  Return a data value at a 2D position. It has no locking. \n\nfloat valueAtSafe(int x, int y, int z) \n  Return a data value at a 3D position. It has no locking.");
    
    EMData_class.def("setValueAt", &EMData::setValueAt, 
		     "setValueAt(int x, int y, int z, float v)\n it does not set the changed flag");
    PyEMData_class.def("row", &PyEMData::py_row,
		       python::return_value_policy<python::manage_new_object>(),
		       "EMData row(int n)\n  extract vector from matrix");
    PyEMData_class.def("col", &PyEMData::py_col,
		       python::return_value_policy<python::manage_new_object>(),
		       "EMData col(int n)\n  extract vector from matrix");
    EMData_class.def("setRow", &EMData::setRow, 
		     "setRow(EMData d,int n)\n  insert vector into matrix");
    EMData_class.def("setCol", &EMData::setCol, 
		     "setCol(EMData d,int n)\n  insert vector into matrix");
    PyEMData_class.def("mxMult", &PyEMData::py_mxMult,
		       python::return_value_policy<python::manage_new_object>(),
		       " EMData mxMult(EMData second)");
    EMData_class.def("dist", &EMData::dist, 
		     EMData_dist("float dist(EMData second, int n=0)"));

    EMData_class.def_pickle(EMData_pickle_suite());

    PyEMData_class.def(python::self += float());
    PyEMData_class.def(python::self -= float());
    PyEMData_class.def(python::self *= float());
    PyEMData_class.def(python::self /= float());

    PyEMData_class.def(python::self += python::self);
    PyEMData_class.def(python::self -= python::self);
    PyEMData_class.def(python::self *= python::self);
    PyEMData_class.def(python::self /= python::self);
    
    PyEMData_class.def(python::self + float());
    PyEMData_class.def(python::self - float());
    PyEMData_class.def(python::self * float());
    PyEMData_class.def(python::self / float());

    PyEMData_class.def(float() + python::self);
    PyEMData_class.def(float() - python::self);
    PyEMData_class.def(float() * python::self);
    PyEMData_class.def(float() / python::self);

    PyEMData_class.def(python::self + python::self);
    PyEMData_class.def(python::self - python::self);
    PyEMData_class.def(python::self * python::self);
    PyEMData_class.def(python::self / python::self);
}
